unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, siComp, ExtCtrls, IniFiles;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    PrintSetup1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    SaveAs1: TMenuItem;
    Save1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    Edit1: TMenuItem;
    Object1: TMenuItem;
    Links1: TMenuItem;
    N3: TMenuItem;
    GoTo1: TMenuItem;
    Replace1: TMenuItem;
    Find1: TMenuItem;
    N4: TMenuItem;
    PasteSpecial1: TMenuItem;
    Paste1: TMenuItem;
    Copy1: TMenuItem;
    Cut1: TMenuItem;
    N5: TMenuItem;
    Repeatcommand1: TMenuItem;
    Undo1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    HowtoUseHelp1: TMenuItem;
    SearchforHelpOn1: TMenuItem;
    Contents1: TMenuItem;
    Button1: TButton;
    Button2: TButton;
    siLangDispatcher1: TsiLangDispatcher;
    siLang1: TsiLang;
    RadioGroup1: TRadioGroup;
    Label1: TLabel;
    Label2: TLabel;
    cbLanguages: TComboBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure cbLanguagesChange(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
  private
    { Private declarations }
    IniFile: TIniFile;
    FLastSelected: Integer;
    procedure LoadLanguage;
    procedure SetLastSelected(const Value: Integer);
  public
    { Public declarations }
    property LastSelected: Integer read FLastSelected write SetLastSelected;
  end;

var
  Form1: TForm1;

implementation

uses Unit2, Unit3;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  Form2.Show;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if Form3 = nil then
    Form3 := TForm3.Create(Application);
  Form3.Show;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
   SR: TSearchRec;
   S: string;
begin
  S := ExtractFilePath(ExpandFileName(ParamStr(0))) + 'Languages\*.sib';
  if FindFirst(S, faAnyFile, SR) <> 0 then Exit;
  repeat
    if SR.Attr and faDirectory = faDirectory then Continue;
    S := SR.Name;
    S := StringReplace(S, '.sib', '', [rfReplaceAll]);
    RadioGroup1.Items.Add(S);
  until FindNext(SR) <> 0;
  FindClose(SR);
  IniFile := TIniFile.Create(ChangeFileExt(ExpandFileName(ParamStr(0)), '.ini'));
  FLastSelected := IniFile.ReadInteger('Options', 'LastLanguage', -1);
  RadioGroup1.ItemIndex := FLastSelected;
end;

procedure TForm1.LoadLanguage;
var
   S: string;
begin
  if (FLastSelected > -1) and (RadioGroup1.Items.Count > FLastSelected) then
  begin
    S := RadioGroup1.Items[FLastSelected];
    S := S + '.sib';
    S := ExtractFilePath(ExpandFileName(ParamStr(0))) + 'Languages\'+ S;
    siLangDispatcher1.FileName := S;  // this ensures all run-time created forms will load content
    siLangDispatcher1.LoadAllFromFile(S); // this ensures all already created forms will load content
  end;
  cbLanguages.Items.Assign(siLangDispatcher1.LangNames);
  cbLanguages.ItemIndex := siLangDispatcher1.ActiveLanguage - 1;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  LastSelected := RadioGroup1.ItemIndex;
  LoadLanguage;
end;

procedure TForm1.cbLanguagesChange(Sender: TObject);
begin
  siLangDispatcher1.ActiveLanguage := cbLanguages.ItemIndex + 1;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.SetLastSelected(const Value: Integer);
begin
  FLastSelected := Value;
  IniFile.WriteInteger('Options', 'LastLanguage', Value);
end;

end.
